program main
  use sep
  implicit none

  real, allocatable     :: infile(:,:,:)
  real, allocatable     :: outfile(:,:,:)
  real, allocatable     :: dipfile(:,:,:)
  real                  :: dx, dy, dz, ox, oy, oz
  integer               :: nx, ny, nz 
  integer               :: i,j,k, n12,n123
  integer               :: ix1, iy1, iz1
  integer               :: ix2, iy2, iz2
  integer               :: ix, iy, iz 
  real                  :: x1, y1, z1 
  real                  :: x2, y2, z2 
  real                  :: x, y, z 
  logical               :: add, verb, v, ldip
  real                  :: pick1, pick2
  integer, allocatable  :: pick(:)
  complex, allocatable  :: picks(:)
  character(len=128)	:: picks_, dipfile_
  character(len=24)	:: color1,color2
  integer               :: icount, lag
  real                  :: denom
  real                  :: dip
  integer               :: wind1,wind2,wind3

  call initpar()

  if (exist_file("infile"))then
      call from_aux("infile","n1",nz); call from_aux("infile","d1",dz); call from_aux("infile","o1",oz)
      call from_aux("infile","n2",nx); call from_aux("infile","d2",dx); call from_aux("infile","o2",ox)
      call from_aux("infile","n3",ny); call from_aux("infile","d3",dy); call from_aux("infile","o3",oy)
      ny=max(1,ny);
      allocate(infile(nz, nx, ny)); 
      call sreed("infile", infile, 4*nz*nx*ny)
      allocate(picks(size(infile)),pick(size(infile)))  
  else
       call from_history('n1',nz); call from_history('d1',dz);  call from_history('o1',oz); 
       call from_history('n2',nx); call from_history('d2',dx);  call from_history('o2',ox); 
       call from_history('n3',ny); call from_history('d3',dy);  call from_history('o3',oy); 
       allocate(infile(nz, nx, ny)); 
       call sreed("in", infile, 4*nz*nx*ny)
       allocate(picks(size(infile)),pick(size(infile)))  
  endif
  allocate(outfile(nz, nx, ny)); 
  allocate(dipfile(nz, nx, ny)); 
  picks_='picks'
  dipfile_='dipfile'
  call from_param("picks",picks_,'pick')
  call from_param("add",add,.true.)
  call from_param("verb",verb,.false.)
  call from_param("lag",lag,0)
  call from_param("denom",denom,2.)
  call from_param("ldip",ldip,.true.)

  call from_param("wind1",wind1,2)
  call from_param("wind2",wind2,2)
  call from_param("wind3",wind3,2)  

  open (file=trim(picks_), unit=10,status='unknown')

  do i=1,size(picks)
        read(10,*,err=31, end=31)color1, pick1, pick2; 
        select case (color1)
        case ('red'     ); pick(i)=1 
        case ('cyan'    ); pick(i)=2
        case ('blue'    );pick(i)=3
        case ('yellow'  );pick(i)=4
        case ('magenta' );pick(i)=5
        case ('white'   );pick(i)=6
        case ('green'   );pick(i)=7
        case ('gray'    );pick(i)=8
        case ('black'   );pick(i)=9
        case ('darkred' );pick(i)=10
        case ('darkcyan'  );pick(i)=11
        case ('darkblue'  );pick(i)=12
        case ('darkyellow');pick(i)=13
        case ('darkmagenta');pick(i)=14 
        case ('darkwhite');pick(i)=15
        case ('darkgreen');pick(i)=16    
        case ('darkgray' );pick(i)=17
        end select
        if(verb)write(0,*)color1, pick1, pick2; 
        picks(i)=cmplx(1.5+(pick1-oz)/dz,1.5+(pick2-ox)/dx); 
  enddo
31      if (verb)write(0,*)'Importing picks....lag',lag
        if (add) then
                outfile=infile
        else
                outfile=0.
        endif
        do k=1,17
        icount=0
        do j=1,i 
                if (pick(j)==float(k))then
                        if(icount==1)then
                                iz1=real(picks(j  ))-lag; ix1=aimag(picks(j  )); iz2=real(picks(j-1))-lag; ix2=aimag(picks(j-1)); n12=ix2-ix2+1
                        else
                                iz1=real(picks(j  ))-lag; ix1=aimag(picks(j  )); iz2=real(picks(j+1))-lag; ix2=aimag(picks(j+1)); n12=ix2-ix2+1
                                icount=1
                        endif
                        if(verb)write(0,'(A30,4I10,4F10.4)')'ix1,ix2,iz1,iz2,picks(j)',ix1,ix2,iz1,iz2,picks(j)  
                        do ix=min(ix1,ix2),max(ix1,ix2)
                                if(ix-wind2/2<1 )cycle
                                if(ix+wind2/2>nx)cycle
                                dip=(1.*(iz2-iz1)/(ix2-ix1))
                                iz=dip*(ix-ix1)+iz1
                                if(ix2-ix1==0)iz=1.*(iz2-iz1)*(ix-ix1)+iz1
                                if(iz<1)then; iz=1; elseif(iz>nz)then; iz=nz; endif
                                outfile(iz,ix,1)=maxval(infile)/denom
                                if(iz-wind1/2<1)then; iz=1+wind1/2; elseif(iz+wind1/2>nz)then; iz=nz-wind1/2; endif
                                dipfile(iz-wind1/2:iz+wind1/2,ix-wind2/2:ix+wind2/2,1)=atan(dip)
                        enddo
                        do iz=min(iz1,iz2),max(iz1,iz2)
                                ix=1.*(ix2-ix1)/(iz2-iz1)*(iz-iz1)+ix1
                                if(iz2-iz1==0)ix=1.*(ix2-ix1)*(iz-iz1)+ix1
                                if(ix<1)then; ix=1; elseif(ix>nx)then; ix=nx; endif
                                outfile(iz,ix,1)=maxval(infile)/denom
                        enddo
                endif
        enddo
        enddo
  call to_history("n1", nz); call to_history("d1", dz); call to_history("o1", oz)
  call to_history("n2", nx); call to_history("d2", dx); call to_history("o2", ox)
  call to_history("n3", ny); call to_history("d3", dy); call to_history("o3", oy)
  call to_history("label1", 'z'); call to_history("label2", 'x'); call to_history("label3", 'y')
  call to_history("esize", 4); 
  call srite("out", outfile, 4*nz*nx)
  call to_history("n1", nz, dipfile_); call to_history("d1", dz, dipfile_); call to_history("o1", oz, dipfile_)
  call to_history("n2", nx, dipfile_); call to_history("d2", dx, dipfile_); call to_history("o2", ox, dipfile_)
  call to_history("n3", ny, dipfile_); call to_history("d3", dy, dipfile_); call to_history("o3", oy, dipfile_)
  call to_history("label1", 'z', dipfile_); call to_history("label2", 'x', dipfile_); call to_history("label3", 'y', dipfile_)
  call to_history("esize", 4, dipfile_); 
  call srite(dipfile_, dipfile, 4*nz*nx)
end program
